{ 4I27 DEMO SOFTWARE - TEST PROGRAM FOR 4I27 }
program HOLD4I28;
uses CRT;

{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }

{$I 4I28LOW }                 { include low level 4I27 I/O }
{ program simple motion test for 4I27 }
const I28Card = $220;                          { default 4I27 location }

var

Motor0 : motor;
Motor1 : motor;
Motor2 : motor;
Motor3 : motor;
MoveStatus : byte;

procedure InitFilterParameters(motorx : motor);
begin
  with motorx.Filter do
  begin
    KP := 10;                                    { relativly low gain }
    KI := 0;                                     { integrated error }
    KD := 0;                                     { some value for damping }
    IL := 0;                                     { low integration limit for now }
  end; {with}
  LoadFilterParameters(motorx);
  UpdateFilter(motorx);
end;

procedure shutdown;
begin
  DisableHBridge(Motor0);
  DisableHBridge(Motor1);
  DisableHBridge(Motor2);
  DisableHBridge(Motor3);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  TurnOffMotor(Motor2);
  TurnOffMotor(Motor3);
  Halt(0);
end;

procedure MoveOK(status : byte);
begin
  if status and ExcessivePosMask <> 0 then
  begin
    writeln('Moves stopped do to excessive position error');
    ShutDown;
  end;
end;


begin                                          {main}
  DirectVideo := false;
  writeln('About to reset the 4I28');
  if not Reset4I28(I28Card) then
  begin
    writeln('Couldn''t reset 4I28 card... Bail-out!');
    Shutdown;
  end
  else
  begin
    writeln('LM629''S sucessfully reset...');
    writeln('Proceeding with set-up');
  end;
  AssignMotor(Motor0,I28Card,0);               { assign motor 0 to first half of first card }
  AssignMotor(Motor1,I28Card,1);               { assign motor 1 to second half of second card }
  AssignMotor(Motor2,I28Card,2);               { assign motor 0 to first half of first card }
  AssignMotor(Motor3,I28Card,3);               { assign motor 1 to second half of second card }
  SetMotionMode(Motor0,PositionMode);          { set up motor 0 for position mode }
  SetMotionMode(Motor1,PositionMode);          { set up motor 1 for position mode }
  SetMotionMode(Motor2,PositionMode);          { set up motor 0 for position mode }
  SetMotionMode(Motor3,PositionMode);          { set up motor 1 for position mode }
  SetSamplingInterval(Motor0,0);               { set motor 0 for minimum sampling interval }
  SetSamplingInterval(Motor1,0);               { set motor 1 for minimum sampling interval }
  SetSamplingInterval(Motor2,0);               { set motor 0 for minimum sampling interval }
  SetSamplingInterval(Motor3,0);               { set motor 1 for minimum sampling interval }
  InitFilterParameters(Motor0);
  InitFilterParameters(Motor1);
  InitFilterParameters(Motor2);
  InitFilterParameters(Motor3);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  TurnOffMotor(Motor2);
  TurnOffMotor(Motor3);
  LoadPosErrForStop(Motor0,15000);
  LoadPosErrForStop(Motor1,15000);
  LoadPosErrForStop(Motor2,15000);
  LoadPosErrForStop(Motor3,15000);
  EnableHbridge(Motor0);
  EnableHBridge(Motor1);
  EnableHbridge(Motor2);
  EnableHBridge(Motor3);
  DefineHome(Motor0);
  DefineHome(Motor1);
  DefineHome(Motor2);
  DefineHome(Motor3);
  MoveStatus := 0;
  writeln('holding all motors now');
  MoveStatus := PolledXYMove(Motor0,Motor1,100,1000,10000,1000);
  MoveStatus := PolledXYMove(Motor2,Motor3,100,1000,10000,1000);
{  ShutDown; }
end.
