{ 4I27 DEMO SOFTWARE - TEST PROGRAM FOR 4I27 }
program IOTEST4I28_7I28;
uses CRT;
{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }

{$I 4I28LOW }                 { include low level 4I28 I/O }
{$I hprint}
{ program simple motion test for 4I28 }

const I28Card = $220;                          { default 4I28 location }

var

Motor0 : motor;
Motor1 : motor;
Motor2 : motor;
Motor3 : motor;
fookey : char;

procedure ReportIOErr(was,expected : word);
begin
  writeln;
  write('7I28 I/O error: expected ');
  HexPrint(expected,4);
  write(' but read back ');
  HexPrint(was,4);
  writeln;
  halt(2);
end;

procedure TestIOBits;
var
rdata : word;
begin
  writeln('Testing 4I28/7I28 I/O bits');
  writeln;
  write('Testing IN bits 0,2,4, OUT bit 0: ');
  SetIOBits(Motor0,1);
  FooDelay(1000); {wait about a millisecond}
  rdata := ReadIOBits(Motor0);
  if rdata <> $0015 then ReportIOErr(rdata,$0015);
  writeln('ok');
  write('Testing I/O bits 1,3,5, OUT bit 1: ');
  SetIOBits(Motor0,2);
  FooDelay(1000); {wait about a millisecond}
  rdata := ReadIOBits(Motor0);
  if rdata <> $002A then ReportIOErr(rdata,$002A);
  writeln('ok');
  write('Testing I/O bits 6,8,10, OUT bit 2: ');
  SetIOBits(Motor0,4);
  FooDelay(1000); {wait about a millisecond}
  rdata := ReadIOBits(Motor0);
  if rdata <> $0540 then ReportIOErr(rdata,$0540);
  writeln('ok');
  write('Testing I/O bits 7,9,11, OUT bit 3: ');
  SetIOBits(Motor0,8);
  FooDelay(1000); {wait about a millisecond}
  rdata := ReadIOBits(Motor0);
  if rdata <> $0A80 then ReportIOErr(rdata,$0A80);
  writeln('ok');
  writeln('press a key to continue');
  FooKey := ReadKey;
  ClrScr;
end;

procedure DoReads;
begin
  while not KeyPressed do
  begin
    gotoxy(1,4);
    write('Motor 0 position = ');
    write(ReadRealPosition(Motor0) : 10,'         ');
    gotoxy(1,6);
    write('Motor 1 position = ');
    write(ReadRealPosition(Motor1) : 10,'         ');
    gotoxy(1,8);
    write('Motor 2 position = ');
    write(ReadRealPosition(Motor2) : 10,'         ');
    gotoxy(1,10);
    write('Motor 3 position = ');
    write(ReadRealPosition(Motor3) : 10,'         ');
    writeln;
  end; {while}
  fookey := Readkey;
end;

procedure Setup;

begin
  DirectVideo:= false;
  writeln('About to reset the 4I28');
  if not Reset4I28(I28Card) then
  begin
    writeln('Couldn''t reset 4I28 card... muddle on!');
  end
  else
  begin
    writeln('LM629''S sucessfully reset...');
    writeln('Proceeding with set-up');
  end;
  AssignMotor(Motor0,I28Card,0);               { assign motor 0 to first qtr of first card }
  AssignMotor(Motor1,I28Card,1);               { assign motor 1 to second qtr of first card }
  AssignMotor(Motor2,I28Card,2);               { assign motor 2 to third qtr of first card }
  AssignMotor(Motor3,I28Card,3);               { assign motor 3 to forth qtr of first card }
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  TurnOffMotor(Motor2);
  TurnOffMotor(Motor3);
  DisableHBridge(Motor0);
  DisableHBridge(Motor1);
  DisableHBridge(Motor2);
  DisableHBridge(Motor3);
  DefineHome(Motor0);
  DefineHome(Motor1);
  DefineHome(Motor2);
  DefineHome(Motor3);
  ClrScr;
end;

begin
  Setup;
  TestIOBits;
  GoToXY(1,1);
  writeln('Testing X motors');
  DoReads;
  port[I28Card+$0C] := $F0;
  GoToXY(1,1);
  writeln('Testing Y motors');
  DoReads;
end.