{ 4I27 DEMO SOFTWARE - TEST PROGRAM FOR 4I27 one channel }
program POS04I27;
{$I general}

{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }

{$I 4I27LOW }                 { include low level 4I27 I/O }
{ program simple motion test for 4I27 }
const I27Card = $200;                          { default 4I27 location }

var

Motor0 : motor;
Motor1 : motor;
MoveStatus : byte;

procedure InitFilterParameters(motorx : motor);
begin
  with motorx.Filter do
  begin
    KP := 100;                                   { relativly low gain }
    KI := 50;                                    { integrated error }
    KD := 2000;                                  { some value for damping }
    IL := 10;                                    { low integration limit for now }
  end; {with}
  LoadFilterParameters(motorx);
  UpdateFilter(motorx);
end;

procedure shutdown;
begin
  DisableHBridge(Motor0);
  DisableHBridge(motor1);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  Halt(0);
end;

procedure MoveOK(status : byte);
begin
  if status and ExcessivePosMask <> 0 then
  begin
    writeln('Moves stopped do to excessive position error');
    ShutDown;
  end;
end;


begin                                          {main}
  writeln('About to reset the 4I27');
  if not ResetSingleChannel4I27(I27Card) then
  begin
    writeln('Couldn''t reset 4I27 card... Bail-out!');
    Shutdown;
  end
  else
  begin
    writeln('LM629 sucessfully reset...');
    writeln('Proceeding with set-up');
  end;
  AssignMotor(Motor0,I27Card,0);               { assign motor 0 to first half of first card }
  SetMotionMode(Motor0,PositionMode);          { set up motor 0 for position mode }
  SetSamplingInterval(Motor0,0);               { set motor 0 for minimum sampling interval }
  InitFilterParameters(Motor0);
  TurnOffMotor(Motor0);
  LoadPosErrForStop(Motor0,500);
  EnableHbridge(Motor0);
  DefineHome(Motor0);
  MoveStatus := 0;
  writeln('About to start moves');
  while not KeyPressed do
  begin
    MoveOK(PolledXMove(Motor0,1320,7500,100));
    MoveOK(PolledXMove(Motor0,2640*3,100000,200));
    MoveOK(PolledXMove(Motor0,2640*-3,10000,1000));
    MoveOK(PolledXMove(Motor0,-2640*30,300000,1000));
    MoveOK(PolledXMove(Motor0,2640*3,500000,25));
    MoveOK(PolledXMove(Motor0,0,800000,1500));
  end; {while}
  ShutDown;
end.
