{ 4I28 DEMO SOFTWARE - TEST PROGRAM FOR 4I27 }
program POS4I28;
uses CRT;

{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }

{$I 4I28LOW }                 { include low level 4I27 I/O }
{ program simple motion test for 4I27 }
const I28Card = $220;                          { default 4I27 location }

var

Motor0 : motor;
Motor1 : motor;
Motor2 : motor;
Motor3 : motor;
MoveStatus : byte;
FooKey : char;

procedure InitFilterParameters(motorx : motor);
begin
  with motorx.Filter do
  begin
    KP := 100;                                   { relativly low gain }
    KI := 50;                                    { integrated error }
    KD := 2000;                                  { some value for damping }
    IL := 10;                                    { low integration limit for now }
  end; {with}
  LoadFilterParameters(motorx);
  UpdateFilter(motorx);
end;

procedure shutdown;
begin
  DisableHBridge(Motor0);
  DisableHBridge(motor1);
  DisableHBridge(Motor2);
  DisableHBridge(motor3);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  TurnOffMotor(Motor2);
  TurnOffMotor(Motor3);
  Halt(0);
end;

procedure Setup;
begin                                          {main}
  DirectVideo := false;
  writeln('About to reset the 4I28');
  if not Reset4I28(I28Card) then
  begin
    writeln('Couldn''t reset 4I28 card... Bail-out!');
    Shutdown;
  end
  else
  begin
    writeln('LM629''S sucessfully reset...');
    writeln('Proceeding with set-up');
  end;
  AssignMotor(Motor0,I28Card,0);               { assign motor 0 }
  AssignMotor(Motor1,I28Card,1);               { assign motor 1 }
  AssignMotor(Motor2,I28Card,2);               { assign motor 2 }
  AssignMotor(Motor3,I28Card,3);               { assign motor 3 }
  SetMotionMode(Motor0,PositionMode);          { set up motor 0 for position mode }
  SetMotionMode(Motor1,PositionMode);          { set up motor 1 for position mode }
  SetMotionMode(Motor2,PositionMode);          { set up motor 2 for position mode }
  SetMotionMode(Motor3,PositionMode);          { set up motor 3 for position mode }
  SetSamplingInterval(Motor0,0);               { set motor 0 for minimum sampling interval }
  SetSamplingInterval(Motor1,0);               { set motor 1 for minimum sampling interval }
  SetSamplingInterval(Motor2,0);               { set motor 2 for minimum sampling interval }
  SetSamplingInterval(Motor3,0);               { set motor 3 for minimum sampling interval }
  InitFilterParameters(Motor0);
  InitFilterParameters(Motor1);
  InitFilterParameters(Motor2);
  InitFilterParameters(Motor3);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  TurnOffMotor(Motor2);
  TurnOffMotor(Motor3);
  LoadPosErrForStop(Motor0,5000);
  LoadPosErrForStop(Motor1,5000);
  LoadPosErrForStop(Motor2,5000);
  LoadPosErrForStop(Motor3,5000);
end;

procedure DoMoves;
begin
  writeln('press a key to test M0X and M1X');
  FooKey := readkey;
  EnableHbridge(Motor0);
  EnableHBridge(Motor1);
  DefineHome(Motor0);
  DefineHome(Motor1);
  MoveStatus := 0;
  PolledXYMove(Motor0,Motor1,1320,1320,10000,1000);
  delay(500);
  PolledXYMove(Motor0,Motor1,2640,2640*3,1000000,1000);
  delay(10);
  PolledXYMove(Motor0,Motor1,2640*7,2640,100000,1000);
  delay(500);
  PolledXYMove(Motor0,Motor1,2640*20,-2640*30,300000,1000);
  delay(500);
  PolledXYMove(Motor0,Motor1,2640*-30,2640*3,500000,50);
  delay(500);
  PolledXYMove(Motor0,Motor1,0,0,800000,1500);
  delay(500);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  DisableHbridge(Motor0);
  DisableHBridge(Motor1);
  MoveStatus := 0;
  writeln('press a key to test M2X and M3X');
  FooKey := readkey;
  EnableHbridge(Motor2);
  EnableHBridge(Motor3);
  DefineHome(Motor2);
  DefineHome(Motor3);
  MoveStatus := 0;
  PolledXYMove(Motor2,Motor3,1320,1320,10000,1000);
  delay(500);
  PolledXYMove(Motor2,Motor3,2640,2640*3,1000000,1000);
  delay(10);
  PolledXYMove(Motor2,Motor3,2640*7,2640,100000,1000);
  delay(500);
  PolledXYMove(Motor2,Motor3,2640*20,-2640*30,300000,1000);
  delay(500);
  PolledXYMove(Motor2,Motor3,2640*-30,2640*3,500000,50);
  delay(500);
  PolledXYMove(Motor2,Motor3,0,0,800000,1500);
  delay(500);
  TurnOffMotor(Motor2);
  TurnOffMotor(Motor3);
  DisableHbridge(Motor2);
  DisableHBridge(Motor3);
  writeln('press a key to test M0Y and M1Y');
  FooKey := readkey;
  SelectY(Motor0);
  SelectY(Motor1);
  EnableHbridge(Motor0);
  EnableHBridge(Motor1);
  DefineHome(Motor0);
  DefineHome(Motor1);
  MoveStatus := 0;
  PolledXYMove(Motor0,Motor1,1320,1320,10000,1000);
  delay(500);
  PolledXYMove(Motor0,Motor1,2640,2640*3,1000000,1000);
  delay(10);
  PolledXYMove(Motor0,Motor1,2640*7,2640,100000,1000);
  delay(500);
  PolledXYMove(Motor0,Motor1,2640*20,-2640*30,300000,1000);
  delay(500);
  PolledXYMove(Motor0,Motor1,2640*-30,2640*3,500000,50);
  delay(500);
  PolledXYMove(Motor0,Motor1,0,0,800000,1500);
  delay(500);
  TurnOffMotor(Motor0);
  TurnOffMotor(Motor1);
  DisableHbridge(Motor0);
  DisableHBridge(Motor1);
  MoveStatus := 0;
  writeln('press a key to test M2Y and M3Y');
  FooKey := readkey;
  SelectY(Motor2);
  SelectY(Motor3);
  EnableHbridge(Motor2);
  EnableHBridge(Motor3);
  DefineHome(Motor2);
  DefineHome(Motor3);
  MoveStatus := 0;
  PolledXYMove(Motor2,Motor3,1320,1320,10000,1000);
  delay(500);
  PolledXYMove(Motor2,Motor3,2640,2640*3,1000000,1000);
  delay(10);
  PolledXYMove(Motor2,Motor3,2640*7,2640,100000,1000);
  delay(500);
  PolledXYMove(Motor2,Motor3,2640*20,-2640*30,300000,1000);
  delay(500);
  PolledXYMove(Motor2,Motor3,2640*-30,2640*3,500000,50);
  delay(500);
  PolledXYMove(Motor2,Motor3,0,0,800000,1500);
  Delay(500);
  TurnOffMotor(Motor2);
  TurnOffMotor(Motor3);
  DisableHbridge(Motor2);
  DisableHBridge(Motor3);
end;

begin
  Setup;
  DoMoves;
  halt;
end.
