{ 4I27 DEMO SOFTWARE - VELOCITY MODE TEST PROGRAM FOR 4I27 }

program VELO4I27;
uses CRT;

{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }

{$I 4I27LOW }                 { include low level 4I27 I/O }
{ program simple test for 4I27 }

const I27Card = $200;                          { default 4I27 location }

var
Motor0 : motor;
VRPM : real;

procedure InitFilterParameters(motorx : motor);
begin
  with motorx.Filter do
  begin
    KP := 100;                                   { relativly low gain }
    KI := 100;                                   { integrated error }
    KD := 3000;                                  { some value for damping }
    IL := 10;                                    { low integration limit for now }
  end; {with}
  LoadFilterParameters(motorx);
  UpdateFilter(motorx);
end;

procedure shutdown;
begin
  DisableHbridge(Motor0);
  TurnOffMotor(Motor0);
  Halt(0);
end;

procedure MoveOK(status : byte);
begin
  if status and ExcessivePosMask <> 0 then
  begin
    writeln('Moves stopped do to excessive position error');
    ShutDown;
  end;
end;


begin                                          {main}
  DirectVideo:= false;
  writeln('About to reset the 4I27');
  if not ResetSingleChannel4I27(I27Card) then
  begin
    writeln('Couldn''t reset 4I27 card... aborting');
    halt(2);
  end;
  writeln('LM629''S sucessfully reset... proceding with set-up');
  AssignMotor(Motor0,I27Card,0);               { assign motor 0 to first half of first card }
  SetMotionMode(Motor0,VelocityMode);          { set up motor 0 for velocity mode }
  SetSamplingInterval(Motor0,0);               { set motor 0 for minimum sampling interval }
  SetClockFrequency(Motor0,8000000);           { 8 Mhz clock }
  SetEncoderLines(Motor0,500);                 { just what we happen to have...}
  InitFilterParameters(Motor0);
  TurnOffMotor(Motor0);
  LoadAcceleration(Motor0,1000);
  LoadPosErrForStop(Motor0,500);
  DefineHome(Motor0);
  EnableHbridge(Motor0);
  writeln(' Enter a 0 for speed to quit');
  writeln;
  while 2+2 = 4 do
  begin
    write('Motor 0 speed in RPM? ');
    Readln(VRPM);
    if VRPM = 0 then ShutDown;
    LoadVelocityInRpm(Motor0,VRPM);
    StartTrajectory(Motor0);
    delay(500);
    MoveOk((ReadLM629Status(Motor0)));
  end; {while}
end.
